Home | All Classes | Main Classes | Annotated | Grouped Classes | Functions |

# QTimer Class Reference

The QTimer class provides timer signals and single-shot timers. More...

    #include <QTimer>

Inherits QObject.

- List of all members, including inherited members
- Compatibility members

### Writable Properties

- 1 writable property inherited from QObject

### Public Functions

- QTimer ( QObject * parent = 0 )
- ~QTimer ()
- bool isActive () const
- int timerId () const

- 24 public functions inherited from QObject

### Public Slots

- void changeInterval ( int msec )
- int start ( int msec, bool sshot = false )
- void stop ()

- 1 public slot inherited from QObject

### Signals

- void timeout ()

- 1 signal inherited from QObject

### Static Public Members

- void singleShot ( int msec, QObject * receiver, const char * member )

- 4 static public members inherited from QObject

### Protected Functions

- 9 protected functions inherited from QObject

## Detailed Description

The QTimer class provides timer signals and single-shot timers.

QTimer uses timer events internally to provide a versatile timer. QTimer is very easy to use: create a QTimer, connect its timeout() signal to the appropriate slots, and call start() to start it. When the time is up it will emit the timeout() signal.

Note that a QTimer object is destroyed automatically when its parent object is destroyed.

Example:

        QTimer *timer = new QTimer(myObject);
        connect(timer, SIGNAL(timeout()), myObject, SLOT(timerDone()));
        timer->start(2000, true); // 2 seconds single-shot timer

You can also use the static singleShot() function to create a single shot timer.

As a special case, a QTimer with a timeout of 0 times out as soon as all the events in the window system's event queue have been processed.

This can be used to do heavy work while providing a snappy user interface:

        QTimer *t = new QTimer(myObject);
        connect(t, SIGNAL(timeout()), SLOT(processOneThing()));
        t->start(0, false);

myObject->processOneThing() will be called repeatedly and should return quickly (typically after processing one data item) so that Qt can deliver events to widgets and stop the timer as soon as it has done all its work. This is the traditional way of implementing heavy work in GUI applications; multithreading is now becoming available on more and more platforms, and we expect that null events will eventually be replaced by threading.

Note that QTimer's accuracy depends on the underlying operating system and hardware. Most platforms support an accuracy of 20ms; some provide more. If Qt is unable to deliver the requested number of timer clicks, it will silently discard some.

An alternative to using QTimer is to call QObject::startTimer() for your object and reimplement the QObject::timerEvent() event handler in your class (which must, of course, inherit QObject). The disadvantage is that timerEvent() does not support such high-level features as single-shot timers or signals.

Some operating systems limit the number of timers that may be used; Qt tries to work around these limitations.

## Member Function Documentation

### QTimer::QTimer ( QObject * parent = 0 )

Constructs a timer with a parent.

Note that the parent object's destructor will destroy this timer object.

### QTimer::~QTimer ()

Destroys the timer.

### void QTimer::changeInterval ( int msec ) `[slot]`

Changes the timeout interval to msec milliseconds.

If the timer signal is pending, it will be stopped and restarted; otherwise it will be started.

See also start() and isActive().

### bool QTimer::isActive () const

Returns true if the timer is running (pending); otherwise returns false.

### void QTimer::singleShot ( int msec, QObject * receiver, const char * member ) `[static]`

This static function calls a slot after a given time interval.

It is very convenient to use this function because you do not need to bother with a timerEvent or create a local QTimer object.

Example:

        #include <qapplication.h>
        #include <qtimer.h>

        int main(int argc, char **argv)
        {
            QApplication a(argc, argv);
            QTimer::singleShot(10*60*1000, &a, SLOT(quit()));
                ... // create and show your widgets
            return a.exec();
        }

This sample program automatically terminates after 10 minutes (600000 milliseconds).

The receiver is the receiving object and the member is the slot. The time interval is msec milliseconds.

Note: function is reentrant.

### int QTimer::start ( int msec, bool sshot = false ) `[slot]`

Starts the timer with a msec milliseconds timeout. Returns the ID of the timer, or zero if the timer failed to start.

If sshot is true, the timer will be activated only once; otherwise it will continue until it is stopped.

Any pending timer will be stopped.

See also singleShot(), stop(), changeInterval(), and isActive().

### void QTimer::stop () `[slot]`

Stops the timer.

See also start().

### void QTimer::timeout () `[signal]`

This signal is emitted when the timer is activated.

### int QTimer::timerId () const

Returns the ID of the timer if the timer is running; otherwise returns -1.